"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var canvas_plugin_common_1 = require("./canvas-plugin.common");
var CanvasGradient_1 = require("./CanvasGradient");
var ColorHelper_1 = require("./ColorHelper");
var TNSPath2D_1 = require("./TNSPath2D");
var image_source_1 = require("tns-core-modules/image-source");
var ImageData_1 = require("./ImageData");
var color_1 = require("tns-core-modules/color");
var TNSImageAsset_1 = require("./TNSImageAsset");
var TNSCanvasRenderingContext2D = (function (_super) {
    __extends(TNSCanvasRenderingContext2D, _super);
    function TNSCanvasRenderingContext2D(context) {
        var _this = _super.call(this) || this;
        _this._shadowColor = 'transparent';
        _this._fillStyle = 'black';
        _this._strokeStyle = 'black';
        _this.context = context;
        return _this;
    }
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "native", {
        get: function () {
            return this.context;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowColor", {
        get: function () {
            return this._shadowColor;
        },
        set: function (color) {
            this.context.setShadowColor(new color_1.Color(color).android);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalAlpha", {
        get: function () {
            return this.context.getGlobalAlpha();
        },
        set: function (alpha) {
            this.context.setGlobalAlpha(alpha);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingEnabled", {
        get: function () {
            return this.context.getImageSmoothingEnabled();
        },
        set: function (enabled) {
            this.context.setImageSmoothingEnabled(enabled);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingQuality", {
        get: function () {
            return this.context.getImageSmoothingQuality().toString();
        },
        set: function (quality) {
            switch (quality) {
                case 'high':
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.High);
                    break;
                case 'medium':
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.Medium);
                    break;
                default:
                    this.context.setImageSmoothingQuality(com.github.triniwiz.canvas.CanvasRenderingContext2D.ImageSmoothingQuality.Low);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineDashOffset", {
        get: function () {
            return this.context.getLineDashOffset();
        },
        set: function (offset) {
            this.context.setLineDashOffset(offset);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineJoin", {
        get: function () {
            return this.context.getLineJoin().toString();
        },
        set: function (join) {
            switch (join) {
                case 'bevel':
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Bevel);
                    break;
                case 'round':
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Round);
                    break;
                default:
                    this.context.setLineJoin(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineJoin.Miter);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineCap", {
        get: function () {
            return this.context.getLineCap().toString();
        },
        set: function (cap) {
            switch (cap) {
                case 'round':
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Round);
                    break;
                case 'square':
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Square);
                    break;
                default:
                    this.context.setLineCap(com.github.triniwiz.canvas.CanvasRenderingContext2D.LineCap.Butt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "miterLimit", {
        get: function () {
            return this.context.getMiterLimit();
        },
        set: function (limit) {
            this.context.setMiterLimit(limit);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowBlur", {
        get: function () {
            return this.context.getShadowBlur();
        },
        set: function (blur) {
            this.context.setShadowBlur(blur);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetX", {
        get: function () {
            return this.context.getShadowOffsetX();
        },
        set: function (x) {
            this.context.setShadowOffsetX(x);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetY", {
        get: function () {
            return this.context.getShadowOffsetY();
        },
        set: function (y) {
            this.context.setShadowOffsetY(y);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "textAlign", {
        get: function () {
            return this.context.getTextAlign().toString();
        },
        set: function (alignment) {
            switch (alignment) {
                case 'start':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Start);
                    break;
                case 'center':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Center);
                    break;
                case 'end':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.End);
                    break;
                case 'right':
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Right);
                    break;
                default:
                    this.context.setTextAlign(com.github.triniwiz.canvas.CanvasTextAlignment.Left);
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalCompositeOperation", {
        get: function () {
            return this.context.getGlobalCompositeOperation().toString();
        },
        set: function (composite) {
            var operation;
            switch (composite.toLowerCase()) {
                case 'source-over':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceOver;
                    break;
                case 'source-in':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceIn;
                    break;
                case 'source-out':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceoOut;
                    break;
                case 'source-atop':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SourceAtop;
                    break;
                case 'destination-over':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationOver;
                    break;
                case 'destination-in':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationIn;
                    break;
                case 'destination-out':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationOut;
                    break;
                case 'destination-atop':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.DestinationAtop;
                    break;
                case 'lighter':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Lighter;
                    break;
                case 'copy':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Copy;
                    break;
                case 'xor':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Xor;
                    break;
                case 'multiply':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Multiply;
                    break;
                case 'screen':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Screen;
                    break;
                case 'overlay':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Overlay;
                    break;
                case 'darken':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Darken;
                    break;
                case 'lighten':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Lighten;
                    break;
                case 'color-dodge':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.ColorDodge;
                    break;
                case 'color-burn':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.ColorBurn;
                    break;
                case 'hard-light':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.HardLight;
                    break;
                case 'soft-light':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.SoftLight;
                    break;
                case 'difference':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Difference;
                    break;
                case 'exclusion':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Exclusion;
                    break;
                case 'hue':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Hue;
                    break;
                case 'saturation':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Saturation;
                    break;
                case 'color':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Color;
                    break;
                case 'luminosity':
                    operation = com.github.triniwiz.canvas.CanvasCompositeOperationType.Luminosity;
                    break;
            }
            this.context.setGlobalCompositeOperation(operation);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "fillStyle", {
        get: function () {
            return this._fillStyle;
        },
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient_1.CanvasGradient) {
                nativeStyle = color.nativeInstance;
                this._fillStyle = color;
            }
            else {
                if (color.startsWith('hsla')) {
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' && color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                this._fillStyle = color;
                nativeStyle = new com.github.triniwiz.canvas.CanvasColorStyle.Color(new color_1.Color(color).android);
            }
            this.context.setFillStyle(nativeStyle);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "strokeStyle", {
        get: function () {
            return this._strokeStyle;
        },
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient_1.CanvasGradient) {
                nativeStyle = color.nativeInstance;
                this._strokeStyle = color;
            }
            else {
                if (color.startsWith('hsla')) {
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' && color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                this._strokeStyle = color;
                nativeStyle = new com.github.triniwiz.canvas.CanvasColorStyle.Color(new color_1.Color(color).android);
            }
            this.context.setStrokeStyle(nativeStyle);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineWidth", {
        get: function () {
            return this.context.getLineWidth();
        },
        set: function (width) {
            this.context.setLineWidth(width);
        },
        enumerable: true,
        configurable: true
    });
    TNSCanvasRenderingContext2D.prototype.addHitRegion = function (region) {
    };
    TNSCanvasRenderingContext2D.prototype.arc = function (x, y, radius, startAngle, endAngle, anticlockwise) {
        this.context.arc(x, y, radius, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.arcTo = function (x1, y1, x2, y2, radius) {
        this.context.arcTo(x1, y1, x2, y2, radius);
    };
    TNSCanvasRenderingContext2D.prototype.beginPath = function () {
        this.context.beginPath();
    };
    TNSCanvasRenderingContext2D.prototype.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
        this.context.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.clearHitRegions = function () {
    };
    TNSCanvasRenderingContext2D.prototype.clearRect = function (x, y, width, height) {
        this.context.clearRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.clip = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.clip(args[0]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.clip(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D) {
            this.context.clip(args[0].native);
        }
        else {
            this.context.clip();
        }
    };
    TNSCanvasRenderingContext2D.prototype.closePath = function () {
        this.context.closePath();
    };
    TNSCanvasRenderingContext2D.prototype.createImageData = function (width, height) {
        if (width instanceof ImageData_1.ImageData) {
            return ImageData_1.ImageData.from(width);
        }
        else {
            return ImageData_1.ImageData.fromNative(this.context.createImageData(width, height));
        }
    };
    TNSCanvasRenderingContext2D.prototype.createLinearGradient = function (x0, y0, x1, y1) {
        return CanvasGradient_1.CanvasGradient.fromNative(this.context.createLinearGradient(x0, y0, x1, y1));
    };
    TNSCanvasRenderingContext2D.prototype.createPattern = function (image, repetition) {
    };
    TNSCanvasRenderingContext2D.prototype.createRadialGradient = function (x0, y0, r0, x1, y1, r1) {
        return CanvasGradient_1.CanvasGradient.fromNative(this.context.createRadialGradient(x0, y0, r0, x1, y1, r1));
    };
    TNSCanvasRenderingContext2D.prototype.drawFocusIfNeeded = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
    };
    TNSCanvasRenderingContext2D.prototype.drawImage = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var image = args[0];
        if (image instanceof TNSImageAsset_1.TNSImageAsset) {
            image = image.native;
        }
        else if (image instanceof image_source_1.ImageSource) {
            image = image.android;
        }
        else if (image instanceof android.graphics.Bitmap) {
            image = image;
        }
        else if (image && typeof image.tagName === 'string' && image.tagName === 'IMG') {
            if (image._imageSource instanceof image_source_1.ImageSource) {
                image = image._imageSource.android;
            }
            else if (image._image instanceof android.graphics.Bitmap) {
                image = image._image;
            }
            else if (image._asset instanceof TNSImageAsset_1.TNSImageAsset) {
                image = image._asset.native;
            }
            else if (typeof image.src === 'string') {
                image = image_source_1.fromFile(image.src).android;
            }
        }
        else if (image &&
            typeof image.tagName === 'string' &&
            image.tagName === 'CANVAS') {
            return;
        }
        if (args.length === 3) {
            this.context.drawImage(image, args[1], args[2]);
        }
        else if (args.length === 5) {
            this.context.drawImage(image, args[1], args[2], args[3], args[4]);
        }
        else if (args.length === 9) {
            this.context.drawImage(image, args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
        }
    };
    TNSCanvasRenderingContext2D.prototype.ellipse = function (x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise) {
        this.context.ellipse(x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.fill = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.fill(args[0]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.fill(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.fill(args[0].native);
        }
        else {
            this.context.fill();
        }
    };
    TNSCanvasRenderingContext2D.prototype.fillRect = function (x, y, width, height) {
        this.context.fillRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.fillText = function (text, x, y, maxWidth) {
        this.context.fillText(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.getImageData = function (sx, sy, sw, sh) {
        return ImageData_1.ImageData.fromNative(this.context.getImageData(sx, sy, sw, sh));
    };
    TNSCanvasRenderingContext2D.prototype.getLineDash = function () {
        return this.context.getLineDash();
    };
    TNSCanvasRenderingContext2D.prototype.isPointInPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.isPointInStroke = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.lineTo = function (x, y) {
        this.context.lineTo(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.measureText = function (text) {
        return undefined;
    };
    TNSCanvasRenderingContext2D.prototype.moveTo = function (x, y) {
        this.context.moveTo(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.putImageData = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!args) {
            return;
        }
        var data = args[0];
        if (args.length === 1) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native);
        }
        else if (args.length === 3) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native, args[1], args[2]);
        }
        else if (args.length === 7) {
            data.native.updateData(Array.from(data.data));
            this.context.putImageData(data.native, args[1], args[2], args[3], args[4], args[5], args[6]);
        }
    };
    TNSCanvasRenderingContext2D.prototype.quadraticCurveTo = function (cpx, cpy, x, y) {
        this.context.quadraticCurveTo(cpx, cpy, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.rect = function (x, y, width, height) {
        this.context.rect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.removeHitRegion = function (id) {
    };
    TNSCanvasRenderingContext2D.prototype.resetTransform = function () {
        this.context.resetTransform();
    };
    TNSCanvasRenderingContext2D.prototype.restore = function () {
        this.context.restore();
    };
    TNSCanvasRenderingContext2D.prototype.rotate = function (angle) {
        this.context.rotate(angle);
    };
    TNSCanvasRenderingContext2D.prototype.save = function () {
        this.context.save();
    };
    TNSCanvasRenderingContext2D.prototype.scale = function (x, y) {
        this.context.scale(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.scrollPathIntoView = function (path) {
    };
    TNSCanvasRenderingContext2D.prototype.setLineDash = function (segments) {
        this.context.setLineDash(segments);
    };
    TNSCanvasRenderingContext2D.prototype.setTransform = function (a, b, c, d, e, f) {
        this.context.setTransform(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.stroke = function (path) {
        if (path) {
            this.context.stroke(path.native);
        }
        else {
            this.context.stroke();
        }
    };
    TNSCanvasRenderingContext2D.prototype.strokeRect = function (x, y, width, height) {
        this.context.strokeRect(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.strokeText = function (text, x, y, maxWidth) {
        this.context.strokeText(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.transform = function (a, b, c, d, e, f) {
        this.context.transform(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.translate = function (x, y) {
        this.context.translate(x, y);
    };
    return TNSCanvasRenderingContext2D;
}(canvas_plugin_common_1.TNSCanvasRenderingContext2DBase));
exports.TNSCanvasRenderingContext2D = TNSCanvasRenderingContext2D;
//# sourceMappingURL=TNSCanvasRenderingContext2D.android.js.map