"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var canvas_plugin_common_1 = require("./canvas-plugin.common");
var CanvasGradient_1 = require("./CanvasGradient");
var ColorHelper_1 = require("./ColorHelper");
var TNSPath2D_1 = require("./TNSPath2D");
var image_source_1 = require("tns-core-modules/image-source");
var ImageData_1 = require("./ImageData");
var TextMetrics_1 = require("./TextMetrics");
var color_1 = require("tns-core-modules/color");
var TNSImageAsset_1 = require("./TNSImageAsset");
var TNSCanvasRenderingContext2D = (function (_super) {
    __extends(TNSCanvasRenderingContext2D, _super);
    function TNSCanvasRenderingContext2D(context) {
        var _this = _super.call(this) || this;
        _this._shadowColor = 'transparent';
        _this._fillStyle = 'black';
        _this._strokeStyle = 'black';
        _this.context = context;
        return _this;
    }
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "native", {
        get: function () {
            return this.context;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowColor", {
        get: function () {
            return this._shadowColor;
        },
        set: function (color) {
            this.context.shadowColor = new color_1.Color(color).ios;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalAlpha", {
        get: function () {
            return this.context.globalAlpha;
        },
        set: function (alpha) {
            this.context.globalAlpha = alpha;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingEnabled", {
        get: function () {
            return this.context.imageSmoothingEnabled;
        },
        set: function (enabled) {
            this.context.imageSmoothingEnabled = enabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "imageSmoothingQuality", {
        get: function () {
            switch (this.context.imageSmoothingQuality) {
                case 1:
                    return 'medium';
                case 2:
                    return 'high';
                default:
                    return 'low';
            }
        },
        set: function (quality) {
            switch (quality) {
                case 'high':
                    this.context.imageSmoothingQuality = 2;
                    break;
                case 'medium':
                    this.context.imageSmoothingQuality = 1;
                    break;
                default:
                    this.context.imageSmoothingQuality = 0;
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineDashOffset", {
        get: function () {
            return this.context.lineDashOffset;
        },
        set: function (offset) {
            this.context.lineDashOffset = offset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineJoin", {
        get: function () {
            switch (this.context.lineJoin) {
                case 0:
                    return 'bevel';
                case 1:
                    return 'round';
                default:
                    return 'miter';
            }
        },
        set: function (join) {
            switch (join) {
                case 'bevel':
                    this.context.lineJoin = 0;
                    break;
                case 'round':
                    this.context.lineJoin = 1;
                    break;
                default:
                    this.context.lineJoin = 2;
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineCap", {
        get: function () {
            switch (this.context.lineCap) {
                case 1:
                    return 'round';
                case 2:
                    return 'square';
                default:
                    return 'butt';
            }
        },
        set: function (cap) {
            switch (cap) {
                case 'round':
                    this.context.lineCap = 1;
                    break;
                case 'square':
                    this.context.lineCap = 2;
                    break;
                default:
                    this.context.lineCap = 0;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "miterLimit", {
        get: function () {
            return this.context.miterLimit;
        },
        set: function (limit) {
            this.context.miterLimit = limit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowBlur", {
        get: function () {
            return this.context.shadowBlur;
        },
        set: function (blur) {
            this.context.shadowBlur = blur;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetX", {
        get: function () {
            return this.context.shadowOffsetX;
        },
        set: function (x) {
            this.context.shadowOffsetX = x;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "shadowOffsetY", {
        get: function () {
            return this.context.shadowOffsetY;
        },
        set: function (y) {
            this.context.shadowOffsetY = y;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "textAlign", {
        get: function () {
            switch (this.context.textAlign) {
                case 1:
                    return 'start';
                case 2:
                    return 'center';
                case 3:
                    return 'end';
                case 4:
                    return 'right';
                default:
                    return 'left';
            }
        },
        set: function (alignment) {
            switch (alignment) {
                case 'start':
                    this.context.textAlign = 1;
                    break;
                case 'center':
                    this.context.textAlign = 2;
                    break;
                case 'end':
                    this.context.textAlign = 3;
                    break;
                case 'right':
                    this.context.textAlign = 4;
                    break;
                default:
                    this.context.textAlign = 0;
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "globalCompositeOperation", {
        get: function () {
            switch (this.context.globalCompositeOperation) {
                case 0:
                    return 'source-over';
                case 1:
                    return 'source-in';
                case 3:
                    return 'source-out';
                case 3:
                    return 'source-atop';
                case 4:
                    return 'destination-over';
                case 5:
                    return 'destination-in';
                case 6:
                    return 'destination-out';
                case 7:
                    return 'destination-atop';
                case 8:
                    return 'lighter';
                case 9:
                    return 'copy';
                case 10:
                    return 'xor';
                case 11:
                    return 'multiply';
                case 12:
                    return 'screen';
                case 13:
                    return 'overlay';
                case 14:
                    return 'darken';
                case 15:
                    return 'lighten';
                case 16:
                    return 'color-dodge';
                case 17:
                    return 'color-burn';
                case 18:
                    return 'hard-light';
                case 19:
                    return 'soft-light';
                case 20:
                    return 'difference';
                case 21:
                    return 'exclusion';
                case 22:
                    return 'hue';
                case 23:
                    return 'saturation';
                case 24:
                    return 'color';
                case 25:
                    return 'luminosity';
                default:
                    return 'source-over';
            }
        },
        set: function (composite) {
            switch (composite.toLowerCase()) {
                case 'source-over':
                    this.context.globalCompositeOperation = 0;
                    break;
                case 'source-in':
                    this.context.globalCompositeOperation = 1;
                    break;
                case 'source-out':
                    this.context.globalCompositeOperation = 2;
                    break;
                case 'source-atop':
                    this.context.globalCompositeOperation = 3;
                    break;
                case 'destination-over':
                    this.context.globalCompositeOperation = 4;
                    break;
                case 'destination-in':
                    this.context.globalCompositeOperation = 5;
                    break;
                case 'destination-out':
                    this.context.globalCompositeOperation = 6;
                    break;
                case 'destination-atop':
                    this.context.globalCompositeOperation = 7;
                    break;
                case 'lighter':
                    this.context.globalCompositeOperation = 8;
                    break;
                case 'copy':
                    this.context.globalCompositeOperation = 9;
                    break;
                case 'xor':
                    this.context.globalCompositeOperation = 10;
                    break;
                case 'multiply':
                    this.context.globalCompositeOperation = 11;
                    break;
                case 'screen':
                    this.context.globalCompositeOperation = 12;
                    break;
                case 'overlay':
                    this.context.globalCompositeOperation = 13;
                    break;
                case 'darken':
                    this.context.globalCompositeOperation = 14;
                    break;
                case 'lighten':
                    this.context.globalCompositeOperation = 15;
                    break;
                case 'color-dodge':
                    this.context.globalCompositeOperation = 16;
                    break;
                case 'color-burn':
                    this.context.globalCompositeOperation = 17;
                    break;
                case 'hard-light':
                    this.context.globalCompositeOperation = 18;
                    break;
                case 'soft-light':
                    this.context.globalCompositeOperation = 19;
                    break;
                case 'difference':
                    this.context.globalCompositeOperation = 20;
                    break;
                case 'exclusion':
                    this.context.globalCompositeOperation = 21;
                    break;
                case 'hue':
                    this.context.globalCompositeOperation = 22;
                    break;
                case 'saturation':
                    this.context.globalCompositeOperation = 23;
                    break;
                case 'color':
                    this.context.globalCompositeOperation = 24;
                    break;
                case 'luminosity':
                    this.context.globalCompositeOperation = 25;
                    break;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "fillStyle", {
        get: function () {
            return this._fillStyle;
        },
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient_1.CanvasGradient) {
                this._fillStyle = color;
                nativeStyle = color.native;
            }
            else {
                var wasHsl = false;
                if (color.startsWith('hsla')) {
                    wasHsl = true;
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    wasHsl = true;
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' &&
                    color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                this._fillStyle = color;
                nativeStyle = Color.alloc().initWithColor(new color_1.Color(color).ios);
            }
            this.context.fillStyle = nativeStyle;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "strokeStyle", {
        get: function () {
            return this._strokeStyle;
        },
        set: function (color) {
            var nativeStyle;
            if (color instanceof CanvasGradient_1.CanvasGradient) {
                nativeStyle = color.native;
                this._strokeStyle = color;
            }
            else {
                if (color.startsWith('hsla')) {
                    color = ColorHelper_1.ColorHandler.HSLAToRGBA(color, false);
                }
                else if (color.startsWith('hsl')) {
                    color = ColorHelper_1.ColorHandler.HSLToRGB(color, false);
                }
                if (typeof color === 'string' &&
                    color.indexOf('Invalid input color') > -1) {
                    color = 'black';
                }
                this._strokeStyle = color;
                nativeStyle = Color.alloc().initWithColor(new color_1.Color(color).ios);
            }
            this.context.strokeStyle = nativeStyle;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSCanvasRenderingContext2D.prototype, "lineWidth", {
        get: function () {
            return this.context.lineWidth;
        },
        set: function (width) {
            this.context.lineWidth = width;
        },
        enumerable: true,
        configurable: true
    });
    TNSCanvasRenderingContext2D.prototype.addHitRegion = function (region) {
    };
    TNSCanvasRenderingContext2D.prototype.arc = function (x, y, radius, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.context.arcWithXYRadiusStartAngleEndAngleAnticlockwise(x, y, radius, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.arcTo = function (x1, y1, x2, y2, radius) {
        this.context.arcToX1Y1X2Y2Radius(x1, y1, x2, y2, radius);
    };
    TNSCanvasRenderingContext2D.prototype.beginPath = function () {
        this.context.beginPath();
    };
    TNSCanvasRenderingContext2D.prototype.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
        this.context.bezierCurveToCp1xCp1yCp2xCp2yXY(cp1x, cp1y, cp2x, cp2y, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.clearHitRegions = function () {
    };
    TNSCanvasRenderingContext2D.prototype.clearRect = function (x, y, width, height) {
        this.context.clearRectWithXYWidthHeight(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.clip = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.clipWithRule(args[0]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.clipWithPathRule(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D) {
            this.context.clipWithPath(args[0].native);
        }
        else {
            this.context.clip();
        }
    };
    TNSCanvasRenderingContext2D.prototype.closePath = function () {
        this.context.closePath();
    };
    TNSCanvasRenderingContext2D.prototype.createImageData = function (width, height) {
        if (width instanceof ImageData_1.ImageData) {
            return ImageData_1.ImageData.fromNative(this.context.createImageDataWithImageData(width.native));
        }
        else {
            return ImageData_1.ImageData.fromNative(this.context.createImageDataWithWidthHeight(width, height));
        }
    };
    TNSCanvasRenderingContext2D.prototype.createLinearGradient = function (x0, y0, x1, y1) {
        return CanvasGradient_1.CanvasGradient.fromNative(this.context.createLinearGradientWithX0Y0X1Y1(x0, y0, x1, y1));
    };
    TNSCanvasRenderingContext2D.prototype.createPattern = function (image, repetition) {
    };
    TNSCanvasRenderingContext2D.prototype.createRadialGradient = function (x0, y0, r0, x1, y1, r1) {
        return CanvasGradient_1.CanvasGradient.fromNative(this.context.createRadialGradientWithX0Y0R0X1Y1R1(x0, y0, r0, x1, y1, r1));
    };
    TNSCanvasRenderingContext2D.prototype.drawFocusIfNeeded = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
    };
    TNSCanvasRenderingContext2D.prototype.drawImage = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!args) {
            return;
        }
        var image = args[0];
        var asset = null;
        var width = 0;
        var height = 0;
        if (image instanceof image_source_1.ImageSource) {
            image = image.ios;
        }
        else if (image instanceof TNSImageAsset_1.TNSImageAsset) {
            image = image;
        }
        else if (image instanceof UIImage) {
            image = image;
        }
        else if (image &&
            typeof image.tagName === 'string' &&
            image.tagName === 'IMG') {
            width = image.width;
            height = image.height;
            if (image._imageSource instanceof image_source_1.ImageSource) {
                image = image._imageSource.ios;
            }
            else if (image._image instanceof UIImage) {
                image = image._image;
            }
            else if (image._asset instanceof TNSImageAsset_1.TNSImageAsset) {
                image = image._asset;
            }
            else if (typeof image.src === 'string') {
                image = image_source_1.fromFile(image.src).ios;
            }
        }
        else if (image &&
            typeof image.tagName === 'string' &&
            image.tagName === 'CANVAS') {
            return;
        }
        if (args.length === 3) {
            if (image instanceof TNSImageAsset_1.TNSImageAsset) {
                this.context.drawImageWithAssetDxDy(image.native, args[1], args[2]);
            }
            else {
                this.context.drawImageWithImageDxDy(image, args[1], args[2]);
            }
        }
        else if (args.length === 5) {
            if (image instanceof TNSImageAsset_1.TNSImageAsset) {
                this.context.drawImageWithAssetDxDyDWidthDHeight(image.native, args[1], args[2], args[3], args[4]);
            }
            else {
                this.context.drawImageWithImageDxDyDWidthDHeight(image, args[1], args[2], args[3], args[4]);
            }
        }
        else if (args.length === 9) {
            if (image instanceof TNSImageAsset_1.TNSImageAsset) {
                this.context.drawImageWithAssetSxSySWidthSHeightDxDyDWidthDHeight(image.native, args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
            }
            else {
                this.context.drawImageWithImageSxSySWidthSHeightDxDyDWidthDHeight(image, args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);
            }
        }
    };
    TNSCanvasRenderingContext2D.prototype.ellipse = function (x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.context.ellipseWithXYRadiusXRadiusYRotationStartAngleEndAngleAnticlockwise(x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise);
    };
    TNSCanvasRenderingContext2D.prototype.fill = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (typeof args[0] === 'string') {
            this.context.fillWithRule(args[0]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.fillWithPathRule(args[0].native, args[1]);
        }
        else if (args[0] instanceof TNSPath2D_1.TNSPath2D && typeof args[1] === 'string') {
            this.context.fillWithPath(args[0].native);
        }
        else {
            this.context.fill();
        }
    };
    TNSCanvasRenderingContext2D.prototype.fillRect = function (x, y, width, height) {
        this.context.fillRectWithXYWidthHeight(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.fillText = function (text, x, y, maxWidth) {
        this.context.fillTextWithTextXYWidth(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.getImageData = function (sx, sy, sw, sh) {
        return ImageData_1.ImageData.fromNative(this.context.getImageDataWithSxSySwSh(sx, sy, sw, sh));
    };
    TNSCanvasRenderingContext2D.prototype.getLineDash = function () {
        return this.context.getLineDash();
    };
    TNSCanvasRenderingContext2D.prototype.isPointInPath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.isPointInStroke = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return false;
    };
    TNSCanvasRenderingContext2D.prototype.lineTo = function (x, y) {
        this.context.lineToXY(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.measureText = function (text) {
        return new TextMetrics_1.TextMetrics(this.context.measureTextWithText(text));
    };
    TNSCanvasRenderingContext2D.prototype.moveTo = function (x, y) {
        this.context.moveToXY(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.putImageData = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!args) {
            return;
        }
        var data = args[0];
        if (args.length === 3) {
            this.context.putImageDataWithImageDataDxDy(data.native, args[1], args[2]);
        }
        else if (args.length === 7) {
            this.context.putImageDataWithImageDataDxDyDirtyXDirtyYDirtyWidthDirtyHeight(data.native, args[1], args[2], args[3], args[4], args[5], args[6]);
        }
    };
    TNSCanvasRenderingContext2D.prototype.quadraticCurveTo = function (cpx, cpy, x, y) {
        this.context.quadraticCurveToCpxCpyXY(cpx, cpy, x, y);
    };
    TNSCanvasRenderingContext2D.prototype.rect = function (x, y, width, height) {
        this.context.rectWithXYWidthHeight(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.removeHitRegion = function (id) {
    };
    TNSCanvasRenderingContext2D.prototype.resetTransform = function () {
        this.context.resetTransform();
    };
    TNSCanvasRenderingContext2D.prototype.restore = function () {
        this.context.restore();
    };
    TNSCanvasRenderingContext2D.prototype.rotate = function (angle) {
        this.context.rotateWithAngle(angle);
    };
    TNSCanvasRenderingContext2D.prototype.save = function () {
        this.context.save();
    };
    TNSCanvasRenderingContext2D.prototype.scale = function (x, y) {
        this.context.scaleWithXY(x, y);
    };
    TNSCanvasRenderingContext2D.prototype.scrollPathIntoView = function (path) {
    };
    TNSCanvasRenderingContext2D.prototype.setLineDash = function (segments) {
        this.context.setLineDashWithSegments(segments);
    };
    TNSCanvasRenderingContext2D.prototype.setTransform = function (a, b, c, d, e, f) {
        this.context.setTransformWithABCDEF(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.stroke = function (path) {
        if (path) {
            this.context.strokeWithPath(path.native);
        }
        else {
            this.context.stroke();
        }
    };
    TNSCanvasRenderingContext2D.prototype.strokeRect = function (x, y, width, height) {
        this.context.strokeRectWithXYWidthHeight(x, y, width, height);
    };
    TNSCanvasRenderingContext2D.prototype.strokeText = function (text, x, y, maxWidth) {
        this.context.strokeTextWithTextXYWidth(text, x, y, maxWidth);
    };
    TNSCanvasRenderingContext2D.prototype.transform = function (a, b, c, d, e, f) {
        this.context.transformWithABCDEF(a, b, c, d, e, f);
    };
    TNSCanvasRenderingContext2D.prototype.translate = function (x, y) {
        this.context.translateWithXY(x, y);
    };
    return TNSCanvasRenderingContext2D;
}(canvas_plugin_common_1.TNSCanvasRenderingContext2DBase));
exports.TNSCanvasRenderingContext2D = TNSCanvasRenderingContext2D;
//# sourceMappingURL=TNSCanvasRenderingContext2D.ios.js.map