"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var canvas_plugin_common_1 = require("./canvas-plugin.common");
var TNSPath2D = (function (_super) {
    __extends(TNSPath2D, _super);
    function TNSPath2D(instance) {
        return _super.call(this, instance) || this;
    }
    TNSPath2D.prototype.addPath = function (path, transform) {
        if (transform) {
            this.nativeInstance.addPath(path.nativeInstance, transform.native);
        }
        else {
            this.nativeInstance.addPath(path.nativeInstance, null);
        }
    };
    TNSPath2D.prototype.arc = function (x, y, radius, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.nativeInstance.arc(x, y, radius, startAngle, endAngle, anticlockwise);
    };
    TNSPath2D.prototype.arcTo = function (x1, y1, x2, y2, radius) {
        this.nativeInstance.arcTo(x1, y1, x2, y2, radius);
    };
    TNSPath2D.prototype.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
        this.nativeInstance.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
    };
    TNSPath2D.prototype.closePath = function () {
        this.nativeInstance.closePath();
    };
    TNSPath2D.prototype.ellipse = function (x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise) {
        if (anticlockwise === void 0) { anticlockwise = false; }
        this.nativeInstance.ellipse(x, y, radiusX, radiusY, rotation, startAngle, endAngle, anticlockwise);
    };
    TNSPath2D.prototype.lineTo = function (x, y) {
        this.nativeInstance.lineTo(x, y);
    };
    TNSPath2D.prototype.moveTo = function (x, y) {
        this.nativeInstance.moveTo(x, y);
    };
    TNSPath2D.prototype.quadraticCurveTo = function (cpx, cpy, x, y) {
        this.nativeInstance.quadraticCurveTo(cpx, cpy, x, y);
    };
    TNSPath2D.prototype.rect = function (x, y, width, height) {
        this.nativeInstance.rect(x, y, width, height);
    };
    return TNSPath2D;
}(canvas_plugin_common_1.TNSPath2DBase));
exports.TNSPath2D = TNSPath2D;
//# sourceMappingURL=TNSPath2D.android.js.map