import { ContainerView } from 'tns-core-modules/ui/core/view';
export * from 'tns-core-modules/ui/core/view';
export declare abstract class TNSCanvasBase extends ContainerView {
    _touchEvents: any;
    constructor();
    private _emitEvent;
    private _touchEventsFN;
    private _getTouchEvent;
    abstract getContext(type: string): TNSCanvasRenderingContext | null;
    abstract getContext(type: string, options: any): TNSCanvasRenderingContext | null;
    abstract getBoundingClientRect(): {
        x: number;
        y: number;
        width: number;
        height: number;
        top: number;
        right: number;
        bottom: number;
        left: number;
    };
}
export declare class TNSImageAssetBase {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
}
export declare enum TNSImageAssetSaveFormat {
    JPG = 0,
    PNG = 1,
    ICO = 2,
    BMP = 3,
    TIFF = 4
}
export interface TNSCanvasRenderingContext {
}
export declare abstract class TNSCanvasRenderingContext2DBase implements TNSCanvasRenderingContext {
    lineWidth: number;
    fillStyle: string | CanvasGradientBase;
    strokeStyle: string | CanvasGradientBase;
    lineCap: string;
    globalCompositeOperation: string;
    font: string;
    globalAlpha: number;
    imageSmoothingEnabled: boolean;
    imageSmoothingQuality: string;
    lineDashOffset: number;
    lineJoin: string;
    miterLimit: number;
    shadowBlur: number;
    shadowColor: string;
    shadowOffsetX: number;
    shadowOffsetY: number;
    textAlign: string;
    _canvas: any;
    readonly canvas: any;
    _type: string;
    readonly type: string;
    abstract addHitRegion(region: any): void;
    abstract arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
    abstract beginPath(): void;
    abstract bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
    abstract clearHitRegions(): void;
    abstract clearRect(x: number, y: number, width: number, height: number): void;
    abstract clip(): void;
    abstract clip(fillRule: string): void;
    abstract clip(path: TNSPath2DBase, fillRule: string): void;
    abstract closePath(): void;
    abstract createImageData(width: number, height: number): ImageDataBase;
    abstract createImageData(data: ImageDataBase): ImageDataBase;
    abstract createLinearGradient(x0: number, y0: number, x1: number, y1: number): any;
    abstract createPattern(image: any, repetition: string): any;
    abstract createRadialGradient(x0: number, y0: number, r0: number, x1: number, y1: number, r1: number): any;
    abstract drawFocusIfNeeded(element: any): void;
    abstract drawFocusIfNeeded(path: any, element: any): void;
    abstract drawImage(image: any, dx: number, dy: number): void;
    abstract drawImage(image: any, dx: number, dy: number, dWidth: number, dHeight: number): void;
    abstract drawImage(image: any, sx: number, sy: number, sWidth: number, sHeight: number, dx: number, dy: number, dWidth: number, dHeight: number): void;
    abstract ellipse(x: number, y: number, radiusX: number, radiusY: number, rotation: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract fill(): void;
    abstract fill(fillRule?: string): void;
    abstract fill(path: TNSPath2DBase, fillRule: string): void;
    abstract fillRect(x: number, y: number, width: number, height: number): void;
    abstract fillText(text: string, x: number, y: number, maxWidth?: number): void;
    abstract getImageData(sx: number, sy: number, sw: number, sh: number): ImageDataBase;
    abstract getLineDash(): number[];
    abstract isPointInPath(x: number, y: number, fillRule: string): boolean;
    abstract isPointInPath(path: TNSPath2DBase, x: number, y: number, fillRule: string): boolean;
    abstract isPointInStroke(x: number, y: number): boolean;
    abstract isPointInStroke(path: TNSPath2DBase, x: number, y: number): boolean;
    abstract lineTo(x: number, y: number): void;
    abstract measureText(text: string): TextMetricsBase;
    abstract moveTo(x: number, y: number): void;
    abstract putImageData(imageData: ImageDataBase, dx: number, dy: number): void;
    abstract putImageData(imageData: ImageDataBase, dx: number, dy: number, dirtyX: number, dirtyY: number, dirtyWidth: number, dirtyHeight: number): void;
    abstract quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): any;
    abstract rect(x: number, y: number, width: number, height: number): void;
    abstract removeHitRegion(id: string): void;
    abstract resetTransform(): void;
    abstract restore(): void;
    abstract rotate(angle: number): void;
    abstract save(): void;
    abstract scale(x: number, y: number): void;
    abstract scrollPathIntoView(): void;
    abstract scrollPathIntoView(path: TNSPath2DBase): void;
    abstract setLineDash(segments: number[]): void;
    abstract setTransform(a: number, b: number, c: number, d: number, e: number, f: number): void;
    abstract stroke(): void;
    abstract stroke(path: TNSPath2DBase): void;
    abstract strokeRect(x: number, y: number, width: number, height: number): void;
    abstract strokeText(text: string, x: number, y: number, maxWidth?: number): void;
    abstract transform(a: number, b: number, c: number, d: number, e: number, f: number): void;
    abstract translate(x: number, y: number): void;
}
export declare class WebGLProgram {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLShader {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLBuffer {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLFramebuffer {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLRenderbuffer {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLTexture {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLActiveInfo {
    readonly name: string;
    readonly size: number;
    readonly type: number;
    constructor(name: string, size: number, type: number);
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLShaderPrecisionFormat {
    readonly rangeMin: number;
    readonly rangeMax: number;
    readonly precision: number;
    constructor(rangeMin: number, rangeMax: number, precision: number);
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLUniformLocation {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare abstract class TNSWebGLRenderingContextBase implements TNSCanvasRenderingContext {
    _native: any;
    constructor(context: any);
    readonly native: any;
    readonly drawingBufferHeight: number;
    readonly drawingBufferWidth: number;
    _canvas: any;
    readonly canvas: any;
    _type: string;
    readonly type: string;
    abstract activeTexture(texture: number): void;
    abstract attachShader(program: WebGLProgram, shader: WebGLShader): void;
    abstract bindAttribLocation(program: WebGLProgram, index: number, name: string): void;
    abstract bindBuffer(target: number, buffer: WebGLBuffer): void;
    abstract bindFramebuffer(target: number, framebuffer: WebGLFramebuffer): void;
    abstract bindRenderbuffer(target: number, renderbuffer: WebGLRenderbuffer): void;
    abstract bindTexture(target: number, texture: WebGLTexture): void;
    abstract blendColor(red: number, green: number, blue: number, alpha: number): void;
    abstract blendEquationSeparate(modeRGB: number, modeAlpha: number): void;
    abstract blendEquation(mode: number): void;
    abstract blendFuncSeparate(srcRGB: number, dstRGB: number, srcAlpha: number, dstAlpha: number): void;
    abstract blendFunc(sfactor: number, dfactor: number): void;
    abstract bufferData(target: number, size: number, usage: number): void;
    abstract bufferData(target: number, srcData: ArrayBuffer | ArrayBufferView, usage: number): void;
    abstract bufferSubData(target: number, offset: number, srcData: ArrayBuffer | ArrayBufferView): void;
    abstract checkFramebufferStatus(target: number): number;
    abstract clearColor(red: number, green: number, blue: number, alpha: number): void;
    abstract clearDepth(depth: number): void;
    abstract clearStencil(stencil: number): void;
    abstract clear(mask: number): void;
    abstract colorMask(red: boolean, green: boolean, blue: boolean, alpha: boolean): void;
    abstract commit(): void;
    abstract compileShader(shader: WebGLShader): void;
    abstract compressedTexImage2D(target: number, level: number, internalformat: number, width: number, height: number, border: number, pixels: ArrayBufferView): void;
    abstract compressedTexSubImage2D(target: number, level: number, xoffset: number, yoffset: number, width: number, height: number, format: number, pixels: ArrayBufferView): void;
    abstract copyTexImage2D(target: number, level: number, internalformat: number, x: number, y: number, width: number, height: number, border: number): void;
    abstract copyTexSubImage2D(target: number, level: number, xoffset: number, yoffset: number, x: number, y: number, width: number, height: number): void;
    abstract createBuffer(): WebGLBuffer;
    abstract createFramebuffer(): WebGLFramebuffer;
    abstract createProgram(): WebGLProgram;
    abstract createRenderbuffer(): WebGLRenderbuffer;
    abstract createShader(type: number): WebGLShader;
    abstract createTexture(): WebGLTexture;
    abstract cullFace(mode: number): void;
    abstract deleteBuffer(buffer: WebGLBuffer): void;
    abstract deleteFramebuffer(frameBuffer: WebGLFramebuffer): void;
    abstract deleteProgram(program: WebGLProgram): void;
    abstract deleteRenderbuffer(renderBuffer: WebGLRenderbuffer): void;
    abstract deleteShader(shader: WebGLRenderbuffer): void;
    abstract deleteTexture(texture: WebGLTexture): void;
    abstract depthFunc(func: number): void;
    abstract depthMask(flag: boolean): void;
    abstract depthRange(zNear: number, zFar: number): void;
    abstract detachShader(program: WebGLProgram, shader: WebGLShader): void;
    abstract disableVertexAttribArray(index: number): void;
    abstract disable(cap: number): void;
    abstract drawArrays(mode: number, first: number, count: number): void;
    abstract drawElements(mode: number, count: number, type: number, offset: number): void;
    abstract enableVertexAttribArray(index: number): void;
    abstract enable(cap: number): void;
    abstract finish(): void;
    abstract flush(): void;
    abstract framebufferRenderbuffer(target: number, attachment: number, renderbuffertarget: number, renderbuffer: WebGLRenderbuffer): void;
    abstract framebufferTexture2D(target: number, attachment: number, textarget: number, texture: WebGLTexture, level: number): void;
    abstract frontFace(mode: number): void;
    abstract generateMipmap(target: number): void;
    abstract getActiveAttrib(program: WebGLProgram, index: number): WebGLActiveInfo;
    abstract getActiveUniform(program: WebGLProgram, index: number): WebGLActiveInfo;
    abstract getAttachedShaders(program: WebGLProgram): WebGLShader[];
    abstract getAttribLocation(program: WebGLProgram, name: string): number;
    abstract getBufferParameter(target: number, pname: number): number;
    abstract getContextAttributes(): any;
    abstract getError(): number;
    abstract getExtension(name: string): any;
    abstract getFramebufferAttachmentParameter(target: number, attachment: number, pname: number): WebGLRenderbuffer | WebGLTexture | number;
    abstract getParameter(pname: number): any;
    abstract getProgramInfoLog(program: WebGLProgram): string;
    abstract getProgramParameter(program: WebGLProgram, pname: number): any;
    abstract getRenderbufferParameter(target: number, pname: number): number;
    abstract getShaderInfoLog(shader: WebGLShader): string;
    abstract getShaderParameter(shader: WebGLShader, pname: number): any;
    abstract getShaderPrecisionFormat(shaderType: number, precisionType: number): WebGLShaderPrecisionFormat | null;
    abstract getShaderSource(shader: WebGLShader): string;
    abstract getSupportedExtensions(): string[];
    abstract getTexParameter(target: number, pname: number): number;
    abstract getUniformLocation(program: WebGLProgram, name: string): WebGLUniformLocation;
    abstract getUniform(program: WebGLProgram, location: WebGLUniformLocation): number;
    abstract getVertexAttribOffset(index: number, pname: number): void;
    abstract getVertexAttrib(index: number, pname: number): any;
    abstract hint(target: number, mode: number): void;
    abstract isBuffer(buffer: WebGLBuffer): boolean;
    abstract isContextLost(): boolean;
    abstract isEnabled(cap: number): boolean;
    abstract isFramebuffer(framebuffer: WebGLFramebuffer): boolean;
    abstract isProgram(program: WebGLProgram): boolean;
    abstract isRenderbuffer(renderbuffer: WebGLRenderbuffer): boolean;
    abstract isShader(shader: WebGLShader): boolean;
    abstract isTexture(texture: WebGLTexture): boolean;
    abstract lineWidth(width: number): void;
    abstract linkProgram(program: WebGLProgram): void;
    abstract pixelStorei(pname: number, param: any): void;
    abstract polygonOffset(factor: number, units: number): void;
    abstract readPixels(x: number, y: number, width: number, height: number, format: number, type: number, pixels: ArrayBufferView): void;
    abstract renderbufferStorage(target: number, internalFormat: number, width: number, height: number): void;
    abstract sampleCoverage(value: number, invert: boolean): void;
    abstract scissor(x: number, y: number, width: number, height: number): void;
    abstract shaderSource(shader: WebGLShader, source: string): void;
    abstract stencilFuncSeparate(face: number, func: number, ref: number, mask: number): void;
    abstract stencilFunc(func: number, ref: number, mask: number): void;
    abstract stencilMaskSeparate(face: number, mask: number): void;
    abstract stencilMask(mask: number): void;
    abstract stencilOpSeparate(face: number, fail: number, zfail: number, zpass: number): void;
    abstract stencilOp(fail: number, zfail: number, zpass: number): void;
    abstract texImage2D(target: number, level: number, internalformat: number, format: number, type: number, pixels: any): void;
    abstract texImage2D(target: number, level: number, internalformat: number, width: number, height: number, border: number, format: number, type: number, pixels: ArrayBufferView): void;
    abstract texParameterf(target: number, pname: number, param: number): void;
    abstract texParameteri(target: number, pname: number, param: number): void;
    abstract texSubImage2D(target: number, level: number, xoffset: number, yoffset: number, width: number, height: number, format: number, type: number, pixels: ArrayBufferView): void;
    abstract texSubImage2D(target: number, level: number, xoffset: number, yoffset: number, format: number, type: number, pixels: any): void;
    abstract uniform1f(location: WebGLUniformLocation, v0: number): void;
    abstract uniform1iv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform1fv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform1i(location: WebGLUniformLocation, v0: number): void;
    abstract uniform2f(location: WebGLUniformLocation, v0: number, v1: number): void;
    abstract uniform2iv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform2fv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform2i(location: WebGLUniformLocation, v0: number, v1: number): void;
    abstract uniform3f(location: WebGLUniformLocation, v0: number, v1: number, v2: number): void;
    abstract uniform3iv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform3fv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform3i(location: WebGLUniformLocation, v0: number, v1: number, v2: number): void;
    abstract uniform4f(location: WebGLUniformLocation, v0: number, v1: number, v2: number, v3: number): void;
    abstract uniform4iv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform4fv(location: WebGLUniformLocation, value: number[]): void;
    abstract uniform4i(location: WebGLUniformLocation, v0: number, v1: number, v2: number, v3: number): void;
    abstract uniformMatrix2fv(location: WebGLUniformLocation, transpose: boolean, value: number[]): void;
    abstract uniformMatrix3fv(location: WebGLUniformLocation, transpose: boolean, value: number[]): void;
    abstract uniformMatrix4fv(location: WebGLUniformLocation, transpose: boolean, value: number[]): void;
    abstract useProgram(program: WebGLProgram): void;
    abstract validateProgram(program: WebGLProgram): void;
    abstract vertexAttrib1f(index: number, v0: number): void;
    abstract vertexAttrib1fv(index: number, value: number[]): void;
    abstract vertexAttrib2f(index: number, v0: number, v1: number): void;
    abstract vertexAttrib2fv(index: number, value: number[]): void;
    abstract vertexAttrib3f(index: number, v0: number, v1: number, v2: number): void;
    abstract vertexAttrib3fv(index: number, value: number[]): void;
    abstract vertexAttrib4f(index: number, v0: number, v1: number, v2: number, v3: number): void;
    abstract vertexAttrib4fv(index: number, value: number[]): void;
    abstract vertexAttribPointer(index: number, size: number, type: number, normalized: boolean, stride: number, offset: number): void;
    abstract viewport(x: number, y: number, width: number, height: number): void;
    readonly DEPTH_BUFFER_BIT: number;
    readonly COLOR_BUFFER_BIT: number;
    readonly STENCIL_BUFFER_BIT: number;
    readonly POINTS: number;
    readonly LINES: number;
    readonly LINE_LOOP: number;
    readonly LINE_STRIP: number;
    readonly TRIANGLES: number;
    readonly TRIANGLE_STRIP: number;
    readonly TRIANGLE_FAN: number;
    readonly ONE: number;
    readonly ZERO: number;
    readonly SRC_COLOR: number;
    readonly ONE_MINUS_SRC_COLOR: number;
    readonly SRC_ALPHA: number;
    readonly ONE_MINUS_SRC_ALPHA: number;
    readonly DST_ALPHA: number;
    readonly ONE_MINUS_DST_ALPHA: number;
    readonly DST_COLOR: number;
    readonly ONE_MINUS_DST_COLOR: number;
    readonly SRC_ALPHA_SATURATE: number;
    readonly CONSTANT_COLOR: number;
    readonly ONE_MINUS_CONSTANT_COLOR: number;
    readonly CONSTANT_ALPHA: number;
    readonly ONE_MINUS_CONSTANT_ALPHA: number;
    readonly FUNC_ADD: number;
    readonly FUNC_SUBTRACT: number;
    readonly FUNC_REVERSE_SUBTRACT: number;
    readonly BLEND_EQUATION: number;
    readonly BLEND_EQUATION_RGB: number;
    readonly BLEND_EQUATION_ALPHA: number;
    readonly BLEND_DST_RGB: number;
    readonly BLEND_SRC_RGB: number;
    readonly BLEND_DST_ALPHA: number;
    readonly BLEND_SRC_ALPHA: number;
    readonly BLEND_COLOR: number;
    readonly ARRAY_BUFFER_BINDING: number;
    readonly ELEMENT_ARRAY_BUFFER_BINDING: number;
    readonly LINE_WIDTH: number;
    readonly ALIASED_POINT_SIZE_RANGE: number;
    readonly ALIASED_LINE_WIDTH_RANGE: number;
    readonly CULL_FACE_MODE: number;
    readonly FRONT_FACE: number;
    readonly DEPTH_RANGE: number;
    readonly DEPTH_WRITEMASK: number;
    readonly DEPTH_CLEAR_VALUE: number;
    readonly DEPTH_FUNC: number;
    readonly STENCIL_CLEAR_VALUE: number;
    readonly STENCIL_FUNC: number;
    readonly STENCIL_FAIL: number;
    readonly STENCIL_PASS_DEPTH_FAIL: number;
    readonly STENCIL_PASS_DEPTH_PASS: number;
    readonly STENCIL_REF: number;
    readonly STENCIL_VALUE_MASK: number;
    readonly STENCIL_WRITEMASK: number;
    readonly STENCIL_BACK_FUNC: number;
    readonly STENCIL_BACK_FAIL: number;
    readonly STENCIL_BACK_PASS_DEPTH_FAIL: number;
    readonly STENCIL_BACK_PASS_DEPTH_PASS: number;
    readonly STENCIL_BACK_REF: number;
    readonly STENCIL_BACK_VALUE_MASK: number;
    readonly STENCIL_BACK_WRITEMASK: number;
    readonly VIEWPORT: number;
    readonly SCISSOR_BOX: number;
    readonly COLOR_CLEAR_VALUE: number;
    readonly COLOR_WRITEMASK: number;
    readonly UNPACK_ALIGNMENT: number;
    readonly PACK_ALIGNMENT: number;
    readonly MAX_TEXTURE_SIZE: number;
    readonly MAX_VIEWPORT_DIMS: number;
    readonly SUBPIXEL_BITS: number;
    readonly RED_BITS: number;
    readonly GREEN_BITS: number;
    readonly BLUE_BITS: number;
    readonly ALPHA_BITS: number;
    readonly DEPTH_BITS: number;
    readonly STENCIL_BITS: number;
    readonly POLYGON_OFFSET_UNITS: number;
    readonly POLYGON_OFFSET_FACTOR: number;
    readonly TEXTURE_BINDING_2D: number;
    readonly SAMPLE_BUFFERS: number;
    readonly SAMPLES: number;
    readonly SAMPLE_COVERAGE_VALUE: number;
    readonly SAMPLE_COVERAGE_INVERT: number;
    readonly COMPRESSED_TEXTURE_FORMATS: number;
    readonly VENDOR: number;
    readonly RENDERER: number;
    readonly VERSION: number;
    readonly IMPLEMENTATION_COLOR_READ_TYPE: number;
    readonly IMPLEMENTATION_COLOR_READ_FORMAT: number;
    readonly BROWSER_DEFAULT_WEBGL: number;
    readonly STATIC_DRAW: number;
    readonly STREAM_DRAW: number;
    readonly DYNAMIC_DRAW: number;
    readonly ARRAY_BUFFER: number;
    readonly ELEMENT_ARRAY_BUFFER: number;
    readonly BUFFER_SIZE: number;
    readonly BUFFER_USAGE: number;
    readonly CURRENT_VERTEX_ATTRIB: number;
    readonly VERTEX_ATTRIB_ARRAY_ENABLED: number;
    readonly VERTEX_ATTRIB_ARRAY_SIZE: number;
    readonly VERTEX_ATTRIB_ARRAY_STRIDE: number;
    readonly VERTEX_ATTRIB_ARRAY_TYPE: number;
    readonly VERTEX_ATTRIB_ARRAY_NORMALIZED: number;
    readonly VERTEX_ATTRIB_ARRAY_POINTER: number;
    readonly VERTEX_ATTRIB_ARRAY_BUFFER_BINDING: number;
    readonly CULL_FACE: number;
    readonly FRONT: number;
    readonly BACK: number;
    readonly FRONT_AND_BACK: number;
    readonly BLEND: number;
    readonly DEPTH_TEST: number;
    readonly DITHER: number;
    readonly POLYGON_OFFSET_FILL: number;
    readonly SAMPLE_ALPHA_TO_COVERAGE: number;
    readonly SAMPLE_COVERAGE: number;
    readonly SCISSOR_TEST: number;
    readonly STENCIL_TEST: number;
    readonly NO_ERROR: number;
    readonly INVALID_ENUM: number;
    readonly INVALID_VALUE: number;
    readonly INVALID_OPERATION: number;
    readonly INVALID_FRAMEBUFFER_OPERATION: number;
    readonly OUT_OF_MEMORY: number;
    readonly CONTEXT_LOST_WEBGL: number;
    readonly CW: number;
    readonly CCW: number;
    readonly DONT_CARE: number;
    readonly FASTEST: number;
    readonly NICEST: number;
    readonly GENERATE_MIPMAP_HINT: number;
    readonly BYTE: number;
    readonly UNSIGNED_BYTE: number;
    readonly UNSIGNED_SHORT: number;
    readonly SHORT: number;
    readonly UNSIGNED_INT: number;
    readonly INT: number;
    readonly FLOAT: number;
    readonly DEPTH_COMPONENT: number;
    readonly ALPHA: number;
    readonly RGB: number;
    readonly RGBA: number;
    readonly LUMINANCE: number;
    readonly LUMINANCE_ALPHA: number;
    readonly UNSIGNED_SHORT_4_4_4_4: number;
    readonly UNSIGNED_SHORT_5_5_5_1: number;
    readonly UNSIGNED_SHORT_5_6_5: number;
    readonly FRAGMENT_SHADER: number;
    readonly VERTEX_SHADER: number;
    readonly COMPILE_STATUS: number;
    readonly DELETE_STATUS: number;
    readonly LINK_STATUS: number;
    readonly VALIDATE_STATUS: number;
    readonly ATTACHED_SHADERS: number;
    readonly ACTIVE_ATTRIBUTES: number;
    readonly ACTIVE_UNIFORMS: number;
    readonly MAX_VERTEX_UNIFORM_VECTORS: number;
    readonly MAX_VARYING_VECTORS: number;
    readonly MAX_COMBINED_TEXTURE_IMAGE_UNITS: number;
    readonly MAX_VERTEX_TEXTURE_IMAGE_UNITS: number;
    readonly MAX_TEXTURE_IMAGE_UNITS: number;
    readonly MAX_VERTEX_ATTRIBS: number;
    readonly MAX_FRAGMENT_UNIFORM_VECTORS: number;
    readonly SHADER_TYPE: number;
    readonly SHADING_LANGUAGE_VERSION: number;
    readonly CURRENT_PROGRAM: number;
    readonly NEVER: number;
    readonly LESS: number;
    readonly EQUAL: number;
    readonly LEQUAL: number;
    readonly GREATER: number;
    readonly NOTEQUAL: number;
    readonly GEQUAL: number;
    readonly ALWAYS: number;
    readonly KEEP: number;
    readonly REPLACE: number;
    readonly INCR: number;
    readonly DECR: number;
    readonly INVERT: number;
    readonly INCR_WRAP: number;
    readonly DECR_WRAP: number;
    readonly NEAREST: number;
    readonly LINEAR: number;
    readonly NEAREST_MIPMAP_NEAREST: number;
    readonly LINEAR_MIPMAP_NEAREST: number;
    readonly NEAREST_MIPMAP_LINEAR: number;
    readonly LINEAR_MIPMAP_LINEAR: number;
    readonly TEXTURE_MAG_FILTER: number;
    readonly TEXTURE_MIN_FILTER: number;
    readonly TEXTURE_WRAP_S: number;
    readonly TEXTURE_WRAP_T: number;
    readonly TEXTURE_2D: number;
    readonly TEXTURE: number;
    readonly TEXTURE_CUBE_MAP: number;
    readonly TEXTURE_BINDING_CUBE_MAP: number;
    readonly TEXTURE_CUBE_MAP_POSITIVE_X: number;
    readonly TEXTURE_CUBE_MAP_NEGATIVE_X: number;
    readonly TEXTURE_CUBE_MAP_POSITIVE_Y: number;
    readonly TEXTURE_CUBE_MAP_NEGATIVE_Y: number;
    readonly TEXTURE_CUBE_MAP_POSITIVE_Z: number;
    readonly TEXTURE_CUBE_MAP_NEGATIVE_Z: number;
    readonly MAX_CUBE_MAP_TEXTURE_SIZE: number;
    readonly TEXTURE0: number;
    readonly TEXTURE1: number;
    readonly TEXTURE2: number;
    readonly TEXTURE3: number;
    readonly TEXTURE4: number;
    readonly TEXTURE5: number;
    readonly TEXTURE6: number;
    readonly TEXTURE7: number;
    readonly TEXTURE8: number;
    readonly TEXTURE9: number;
    readonly TEXTURE10: number;
    readonly TEXTURE11: number;
    readonly TEXTURE12: number;
    readonly TEXTURE13: number;
    readonly TEXTURE14: number;
    readonly TEXTURE15: number;
    readonly TEXTURE16: number;
    readonly TEXTURE17: number;
    readonly TEXTURE18: number;
    readonly TEXTURE19: number;
    readonly TEXTURE20: number;
    readonly TEXTURE21: number;
    readonly TEXTURE22: number;
    readonly TEXTURE23: number;
    readonly TEXTURE24: number;
    readonly TEXTURE25: number;
    readonly TEXTURE26: number;
    readonly TEXTURE27: number;
    readonly TEXTURE28: number;
    readonly TEXTURE29: number;
    readonly TEXTURE30: number;
    readonly TEXTURE31: number;
    readonly ACTIVE_TEXTURE: number;
    readonly REPEAT: number;
    readonly CLAMP_TO_EDGE: number;
    readonly MIRRORED_REPEAT: number;
    readonly FLOAT_VEC2: number;
    readonly FLOAT_VEC3: number;
    readonly FLOAT_VEC4: number;
    readonly INT_VEC2: number;
    readonly INT_VEC3: number;
    readonly INT_VEC4: number;
    readonly BOOL: number;
    readonly BOOL_VEC2: number;
    readonly BOOL_VEC3: number;
    readonly BOOL_VEC4: number;
    readonly FLOAT_MAT2: number;
    readonly FLOAT_MAT3: number;
    readonly FLOAT_MAT4: number;
    readonly SAMPLER_2D: number;
    readonly SAMPLER_CUBE: number;
    readonly LOW_FLOAT: number;
    readonly MEDIUM_FLOAT: number;
    readonly HIGH_FLOAT: number;
    readonly LOW_INT: number;
    readonly MEDIUM_INT: number;
    readonly HIGH_INT: number;
    readonly FRAMEBUFFER: number;
    readonly RENDERBUFFER: number;
    readonly RGBA4: number;
    readonly RGB565: number;
    readonly RGB5_A1: number;
    readonly DEPTH_COMPONENT16: number;
    readonly STENCIL_INDEX8: number;
    readonly DEPTH_STENCIL: number;
    readonly RENDERBUFFER_WIDTH: number;
    readonly RENDERBUFFER_HEIGHT: number;
    readonly RENDERBUFFER_INTERNAL_FORMAT: number;
    readonly RENDERBUFFER_RED_SIZE: number;
    readonly RENDERBUFFER_GREEN_SIZE: number;
    readonly RENDERBUFFER_BLUE_SIZE: number;
    readonly RENDERBUFFER_ALPHA_SIZE: number;
    readonly RENDERBUFFER_DEPTH_SIZE: number;
    readonly RENDERBUFFER_STENCIL_SIZE: number;
    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE: number;
    readonly FRAMEBUFFER_ATTACHMENT_OBJECT_NAME: number;
    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL: number;
    readonly FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE: number;
    readonly COLOR_ATTACHMENT0: number;
    readonly DEPTH_ATTACHMENT: number;
    readonly STENCIL_ATTACHMENT: number;
    readonly DEPTH_STENCIL_ATTACHMENT: number;
    readonly NONE: number;
    readonly FRAMEBUFFER_COMPLETE: number;
    readonly FRAMEBUFFER_INCOMPLETE_ATTACHMENT: number;
    readonly FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: number;
    readonly FRAMEBUFFER_INCOMPLETE_DIMENSIONS: number;
    readonly FRAMEBUFFER_UNSUPPORTED: number;
    readonly FRAMEBUFFER_BINDING: number;
    readonly RENDERBUFFER_BINDING: number;
    readonly MAX_RENDERBUFFER_SIZE: number;
    readonly UNPACK_COLORSPACE_CONVERSION_WEBGL: number;
    readonly UNPACK_FLIP_Y_WEBGL: number;
    readonly UNPACK_PREMULTIPLY_ALPHA_WEBGL: number;
}
export declare abstract class TNSPath2DBase {
    protected nativeInstance: any;
    constructor(instance: any);
    abstract addPath(path: TNSPath2DBase, transform?: TNSDOMMatrixBase): void;
    abstract closePath(): void;
    abstract moveTo(x: number, y: number): void;
    abstract lineTo(x: number, y: number): void;
    abstract bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
    abstract quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): void;
    abstract arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
    abstract ellipse(x: number, y: number, radiusX: number, radiusY: number, rotation: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract rect(x: number, y: number, width: number, height: number): void;
    readonly native: any;
}
export declare abstract class TNSDOMMatrixBase {
    protected nativeInstance: any;
    constructor(nativeInstance: any);
    a: number;
    b: number;
    c: number;
    d: number;
    e: number;
    f: number;
    readonly native: any;
}
export declare class ImageDataBase {
    protected nativeInstance: any;
    constructor(nativeInstance: any);
    width: number;
    height: number;
    data: any;
    readonly native: any;
}
export declare abstract class CanvasGradientBase {
    abstract addColorStop(offset: number, color: any): void;
}
export declare abstract class CanvasPattern {
}
export declare class TextMetricsBase {
    protected nativeInstance: any;
    constructor(nativeInstance: any);
}
export declare class WebGLQuery {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLSampler {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLTransformFeedback {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLVertexArrayObject {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
export declare class WebGLSync {
    private nativeInstance;
    constructor(nativeInstance: any);
    readonly native: any;
    toString(): string;
    [Symbol.toStringTag]: string;
}
