"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("tns-core-modules/ui/core/view");
var gestures_1 = require("tns-core-modules/ui/gestures/gestures");
var platform_1 = require("tns-core-modules/platform");
__export(require("tns-core-modules/ui/core/view"));
var TNSCanvasBase = (function (_super) {
    __extends(TNSCanvasBase, _super);
    function TNSCanvasBase() {
        var _this = _super.call(this) || this;
        _this._touchEvents = _this._touchEventsFN.bind(_this);
        _this.on('touch, pan', _this._touchEvents);
        return _this;
    }
    TNSCanvasBase.prototype._emitEvent = function (name, event) {
        this.notify(this._getTouchEvent(name, event, this));
    };
    TNSCanvasBase.prototype._touchEventsFN = function (event) {
        if (event.eventName === 'touch') {
            switch (event.action) {
                case 'down':
                    this._emitEvent('touchstart', event);
                    break;
                case 'up':
                    this._emitEvent('touchend', event);
                    break;
                case 'cancel':
                    this._emitEvent('touchcancel', event);
                    break;
                case 'move':
                    break;
                default:
                    break;
            }
        }
        else if (event.eventName === 'pan') {
            if (event.state === gestures_1.GestureStateTypes.began || event.state === gestures_1.GestureStateTypes.changed) {
                this._emitEvent('touchmove', event);
            }
        }
    };
    TNSCanvasBase.prototype._getTouchEvent = function (name, event, target) {
        var pointers = new TouchList();
        var scale = platform_1.screen.mainScreen.scale;
        var activePointer = {};
        if (name === 'touchmove') {
            activePointer = {
                clientX: event.deltaX * scale,
                clientY: event.deltaY * scale,
                force: 0.0,
                identifier: 0,
                pageX: event.deltaX * scale,
                pageY: event.deltaY * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: event.deltaX * scale,
                screenY: event.deltaY * scale,
                target: target,
            };
            pointers.push({
                clientX: event.deltaX * scale,
                clientY: event.deltaY * scale,
                force: 0.0,
                identifier: 0,
                pageX: event.deltaX * scale,
                pageY: event.deltaY * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: event.deltaX * scale,
                screenY: event.deltaY * scale,
                target: target,
            });
        }
        else {
            var count = event.getAllPointers().length;
            var point = event.getActivePointers()[0];
            activePointer = {
                clientX: point.getX() * scale,
                clientY: point.getY() * scale,
                force: 0.0,
                identifier: 0,
                pageX: point.getX() * scale,
                pageY: point.getY() * scale,
                radiusX: 0,
                radiusY: 0,
                rotationAngle: 0,
                screenX: point.getX() * scale,
                screenY: point.getY() * scale,
            };
            for (var i = 0; i < count; i++) {
                var point_1 = event.getAllPointers()[i];
                pointers.push({
                    clientX: point_1.getX(),
                    clientY: point_1.getY(),
                    force: 0.0,
                    identifier: i,
                    pageX: point_1.getX(),
                    pageY: point_1.getY(),
                    radiusX: 0,
                    radiusY: 0,
                    rotationAngle: 0,
                    screenX: point_1.getX(),
                    screenY: point_1.getY(),
                    target: target,
                });
            }
        }
        return __assign({ eventName: name, object: null, defaultPrevented: false, cancelable: false, altKey: false, changedTouches: pointers, ctrlKey: false, metaKey: false, shiftKey: false, targetTouches: pointers, touches: pointers, preventDefault: function () {
            }, target: target }, activePointer);
    };
    TNSCanvasBase = __decorate([
        view_1.CSSType('TNSCanvas'),
        __metadata("design:paramtypes", [])
    ], TNSCanvasBase);
    return TNSCanvasBase;
}(view_1.ContainerView));
exports.TNSCanvasBase = TNSCanvasBase;
var TouchList = (function (_super) {
    __extends(TouchList, _super);
    function TouchList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TouchList.prototype.item = function (index) {
        return this[index];
    };
    return TouchList;
}(Array));
var TNSImageAssetBase = (function () {
    function TNSImageAssetBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(TNSImageAssetBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSImageAssetBase;
}());
exports.TNSImageAssetBase = TNSImageAssetBase;
var TNSImageAssetSaveFormat;
(function (TNSImageAssetSaveFormat) {
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["JPG"] = 0] = "JPG";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["PNG"] = 1] = "PNG";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["ICO"] = 2] = "ICO";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["BMP"] = 3] = "BMP";
    TNSImageAssetSaveFormat[TNSImageAssetSaveFormat["TIFF"] = 4] = "TIFF";
})(TNSImageAssetSaveFormat = exports.TNSImageAssetSaveFormat || (exports.TNSImageAssetSaveFormat = {}));
var TNSCanvasRenderingContext2DBase = (function () {
    function TNSCanvasRenderingContext2DBase() {
        this._type = 'none';
    }
    Object.defineProperty(TNSCanvasRenderingContext2DBase.prototype, "canvas", {
        get: function () {
            return this._canvas;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TNSCanvasRenderingContext2DBase.prototype, "type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    return TNSCanvasRenderingContext2DBase;
}());
exports.TNSCanvasRenderingContext2DBase = TNSCanvasRenderingContext2DBase;
var WebGLProgram = (function () {
    function WebGLProgram(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLProgram';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLProgram.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLProgram.prototype.toString = function () {
        return '[object WebGLProgram]';
    };
    return WebGLProgram;
}());
exports.WebGLProgram = WebGLProgram;
var WebGLShader = (function () {
    function WebGLShader(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLShader';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLShader.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLShader.prototype.toString = function () {
        return '[object WebGLShader]';
    };
    return WebGLShader;
}());
exports.WebGLShader = WebGLShader;
var WebGLBuffer = (function () {
    function WebGLBuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLBuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLBuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLBuffer.prototype.toString = function () {
        return '[object WebGLBuffer]';
    };
    return WebGLBuffer;
}());
exports.WebGLBuffer = WebGLBuffer;
var WebGLFramebuffer = (function () {
    function WebGLFramebuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLFramebuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLFramebuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLFramebuffer.prototype.toString = function () {
        return '[object WebGLFramebuffer]';
    };
    return WebGLFramebuffer;
}());
exports.WebGLFramebuffer = WebGLFramebuffer;
var WebGLRenderbuffer = (function () {
    function WebGLRenderbuffer(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLRenderbuffer';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLRenderbuffer.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLRenderbuffer.prototype.toString = function () {
        return '[object WebGLRenderbuffer]';
    };
    return WebGLRenderbuffer;
}());
exports.WebGLRenderbuffer = WebGLRenderbuffer;
var WebGLTexture = (function () {
    function WebGLTexture(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLTexture';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLTexture.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLTexture.prototype.toString = function () {
        return '[object WebGLTexture]';
    };
    return WebGLTexture;
}());
exports.WebGLTexture = WebGLTexture;
var WebGLActiveInfo = (function () {
    function WebGLActiveInfo(name, size, type) {
        this[Symbol.toStringTag] = 'WebGLActiveInfo';
        this.name = name;
        this.size = size;
        this.type = type;
    }
    WebGLActiveInfo.prototype.toString = function () {
        return '[object WebGLActiveInfo]';
    };
    return WebGLActiveInfo;
}());
exports.WebGLActiveInfo = WebGLActiveInfo;
var WebGLShaderPrecisionFormat = (function () {
    function WebGLShaderPrecisionFormat(rangeMin, rangeMax, precision) {
        this[Symbol.toStringTag] = 'WebGLShaderPrecisionFormat';
        this.rangeMin = rangeMin;
        this.rangeMax = rangeMax;
        this.precision = precision;
    }
    WebGLShaderPrecisionFormat.prototype.toString = function () {
        return '[object WebGLShaderPrecisionFormat]';
    };
    return WebGLShaderPrecisionFormat;
}());
exports.WebGLShaderPrecisionFormat = WebGLShaderPrecisionFormat;
var WebGLUniformLocation = (function () {
    function WebGLUniformLocation(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLUniformLocation';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLUniformLocation.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLUniformLocation.prototype.toString = function () {
        return '[object WebGLUniformLocation]';
    };
    return WebGLUniformLocation;
}());
exports.WebGLUniformLocation = WebGLUniformLocation;
var TNSWebGLRenderingContextBase = (function () {
    function TNSWebGLRenderingContextBase(context) {
        this._type = 'none';
        this._native = context;
    }
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "native", {
        get: function () {
            return this._native;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "canvas", {
        get: function () {
            return this._canvas;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_BUFFER_BIT", {
        get: function () { return this.native.DEPTH_BUFFER_BIT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COLOR_BUFFER_BIT", {
        get: function () { return this.native.COLOR_BUFFER_BIT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BUFFER_BIT", {
        get: function () { return this.native.STENCIL_BUFFER_BIT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "POINTS", {
        get: function () { return this.native.POINTS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINES", {
        get: function () { return this.native.LINES; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINE_LOOP", {
        get: function () { return this.native.LINE_LOOP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINE_STRIP", {
        get: function () { return this.native.LINE_STRIP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TRIANGLES", {
        get: function () { return this.native.TRIANGLES; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TRIANGLE_STRIP", {
        get: function () { return this.native.TRIANGLE_STRIP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TRIANGLE_FAN", {
        get: function () { return this.native.TRIANGLE_FAN; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE", {
        get: function () { return this.native.ONE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ZERO", {
        get: function () { return this.native.ZERO; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SRC_COLOR", {
        get: function () { return this.native.SRC_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_SRC_COLOR", {
        get: function () { return this.native.ONE_MINUS_SRC_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SRC_ALPHA", {
        get: function () { return this.native.SRC_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_SRC_ALPHA", {
        get: function () { return this.native.ONE_MINUS_SRC_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DST_ALPHA", {
        get: function () { return this.native.DST_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_DST_ALPHA", {
        get: function () { return this.native.ONE_MINUS_DST_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DST_COLOR", {
        get: function () { return this.native.DST_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_DST_COLOR", {
        get: function () { return this.native.ONE_MINUS_DST_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SRC_ALPHA_SATURATE", {
        get: function () { return this.native.SRC_ALPHA_SATURATE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CONSTANT_COLOR", {
        get: function () { return this.native.CONSTANT_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_CONSTANT_COLOR", {
        get: function () { return this.native.ONE_MINUS_CONSTANT_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CONSTANT_ALPHA", {
        get: function () { return this.native.CONSTANT_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ONE_MINUS_CONSTANT_ALPHA", {
        get: function () { return this.native.ONE_MINUS_CONSTANT_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FUNC_ADD", {
        get: function () { return this.native.FUNC_ADD; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FUNC_SUBTRACT", {
        get: function () { return this.native.FUNC_SUBTRACT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FUNC_REVERSE_SUBTRACT", {
        get: function () { return this.native.FUNC_REVERSE_SUBTRACT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_EQUATION", {
        get: function () { return this.native.BLEND_EQUATION; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_EQUATION_RGB", {
        get: function () { return this.native.BLEND_EQUATION_RGB; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_EQUATION_ALPHA", {
        get: function () { return this.native.BLEND_EQUATION_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_DST_RGB", {
        get: function () { return this.native.BLEND_DST_RGB; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_SRC_RGB", {
        get: function () { return this.native.BLEND_SRC_RGB; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_DST_ALPHA", {
        get: function () { return this.native.BLEND_DST_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_SRC_ALPHA", {
        get: function () { return this.native.BLEND_SRC_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND_COLOR", {
        get: function () { return this.native.BLEND_COLOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ARRAY_BUFFER_BINDING", {
        get: function () { return this.native.ARRAY_BUFFER_BINDING; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ELEMENT_ARRAY_BUFFER_BINDING", {
        get: function () { return this.native.ELEMENT_ARRAY_BUFFER_BINDING; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINE_WIDTH", {
        get: function () { return this.native.LINE_WIDTH; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ALIASED_POINT_SIZE_RANGE", {
        get: function () { return this.native.ALIASED_POINT_SIZE_RANGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ALIASED_LINE_WIDTH_RANGE", {
        get: function () { return this.native.ALIASED_LINE_WIDTH_RANGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CULL_FACE_MODE", {
        get: function () { return this.native.CULL_FACE_MODE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRONT_FACE", {
        get: function () { return this.native.FRONT_FACE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_RANGE", {
        get: function () { return this.native.DEPTH_RANGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_WRITEMASK", {
        get: function () { return this.native.DEPTH_WRITEMASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_CLEAR_VALUE", {
        get: function () { return this.native.DEPTH_CLEAR_VALUE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_FUNC", {
        get: function () { return this.native.DEPTH_FUNC; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_CLEAR_VALUE", {
        get: function () { return this.native.STENCIL_CLEAR_VALUE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_FUNC", {
        get: function () { return this.native.STENCIL_FUNC; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_FAIL", {
        get: function () { return this.native.STENCIL_FAIL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_PASS_DEPTH_FAIL", {
        get: function () { return this.native.STENCIL_PASS_DEPTH_FAIL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_PASS_DEPTH_PASS", {
        get: function () { return this.native.STENCIL_PASS_DEPTH_PASS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_REF", {
        get: function () { return this.native.STENCIL_REF; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_VALUE_MASK", {
        get: function () { return this.native.STENCIL_VALUE_MASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_WRITEMASK", {
        get: function () { return this.native.STENCIL_WRITEMASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_FUNC", {
        get: function () { return this.native.STENCIL_BACK_FUNC; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_FAIL", {
        get: function () { return this.native.STENCIL_BACK_FAIL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_PASS_DEPTH_FAIL", {
        get: function () { return this.native.STENCIL_BACK_PASS_DEPTH_FAIL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_PASS_DEPTH_PASS", {
        get: function () { return this.native.STENCIL_BACK_PASS_DEPTH_PASS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_REF", {
        get: function () { return this.native.STENCIL_BACK_REF; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_VALUE_MASK", {
        get: function () { return this.native.STENCIL_BACK_VALUE_MASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BACK_WRITEMASK", {
        get: function () { return this.native.STENCIL_BACK_WRITEMASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VIEWPORT", {
        get: function () { return this.native.VIEWPORT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SCISSOR_BOX", {
        get: function () { return this.native.SCISSOR_BOX; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COLOR_CLEAR_VALUE", {
        get: function () { return this.native.COLOR_CLEAR_VALUE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COLOR_WRITEMASK", {
        get: function () { return this.native.COLOR_WRITEMASK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNPACK_ALIGNMENT", {
        get: function () { return this.native.UNPACK_ALIGNMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "PACK_ALIGNMENT", {
        get: function () { return this.native.PACK_ALIGNMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_TEXTURE_SIZE", {
        get: function () { return this.native.MAX_TEXTURE_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_VIEWPORT_DIMS", {
        get: function () { return this.native.MAX_VIEWPORT_DIMS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SUBPIXEL_BITS", {
        get: function () { return this.native.SUBPIXEL_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RED_BITS", {
        get: function () { return this.native.RED_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "GREEN_BITS", {
        get: function () { return this.native.GREEN_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLUE_BITS", {
        get: function () { return this.native.BLUE_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ALPHA_BITS", {
        get: function () { return this.native.ALPHA_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_BITS", {
        get: function () { return this.native.DEPTH_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_BITS", {
        get: function () { return this.native.STENCIL_BITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "POLYGON_OFFSET_UNITS", {
        get: function () { return this.native.POLYGON_OFFSET_UNITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "POLYGON_OFFSET_FACTOR", {
        get: function () { return this.native.POLYGON_OFFSET_FACTOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_BINDING_2D", {
        get: function () { return this.native.TEXTURE_BINDING_2D; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLE_BUFFERS", {
        get: function () { return this.native.SAMPLE_BUFFERS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLES", {
        get: function () { return this.native.SAMPLES; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLE_COVERAGE_VALUE", {
        get: function () { return this.native.SAMPLE_COVERAGE_VALUE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLE_COVERAGE_INVERT", {
        get: function () { return this.native.SAMPLE_COVERAGE_INVERT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COMPRESSED_TEXTURE_FORMATS", {
        get: function () { return this.native.COMPRESSED_TEXTURE_FORMATS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VENDOR", {
        get: function () { return this.native.VENDOR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERER", {
        get: function () { return this.native.RENDERER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERSION", {
        get: function () { return this.native.VERSION; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "IMPLEMENTATION_COLOR_READ_TYPE", {
        get: function () { return this.native.IMPLEMENTATION_COLOR_READ_TYPE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "IMPLEMENTATION_COLOR_READ_FORMAT", {
        get: function () { return this.native.IMPLEMENTATION_COLOR_READ_FORMAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BROWSER_DEFAULT_WEBGL", {
        get: function () { return this.native.BROWSER_DEFAULT_WEBGL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STATIC_DRAW", {
        get: function () { return this.native.STATIC_DRAW; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STREAM_DRAW", {
        get: function () { return this.native.STREAM_DRAW; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DYNAMIC_DRAW", {
        get: function () { return this.native.DYNAMIC_DRAW; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ARRAY_BUFFER", {
        get: function () { return this.native.ARRAY_BUFFER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ELEMENT_ARRAY_BUFFER", {
        get: function () { return this.native.ELEMENT_ARRAY_BUFFER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BUFFER_SIZE", {
        get: function () { return this.native.BUFFER_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BUFFER_USAGE", {
        get: function () { return this.native.BUFFER_USAGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CURRENT_VERTEX_ATTRIB", {
        get: function () { return this.native.CURRENT_VERTEX_ATTRIB; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_ENABLED", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_ENABLED; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_SIZE", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_STRIDE", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_STRIDE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_TYPE", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_TYPE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_NORMALIZED", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_NORMALIZED; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_POINTER", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_POINTER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING", {
        get: function () { return this.native.VERTEX_ATTRIB_ARRAY_BUFFER_BINDING; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CULL_FACE", {
        get: function () { return this.native.CULL_FACE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRONT", {
        get: function () { return this.native.FRONT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BACK", {
        get: function () { return this.native.BACK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRONT_AND_BACK", {
        get: function () { return this.native.FRONT_AND_BACK; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BLEND", {
        get: function () { return this.native.BLEND; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_TEST", {
        get: function () { return this.native.DEPTH_TEST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DITHER", {
        get: function () { return this.native.DITHER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "POLYGON_OFFSET_FILL", {
        get: function () { return this.native.POLYGON_OFFSET_FILL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLE_ALPHA_TO_COVERAGE", {
        get: function () { return this.native.SAMPLE_ALPHA_TO_COVERAGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLE_COVERAGE", {
        get: function () { return this.native.SAMPLE_COVERAGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SCISSOR_TEST", {
        get: function () { return this.native.SCISSOR_TEST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_TEST", {
        get: function () { return this.native.STENCIL_TEST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NO_ERROR", {
        get: function () { return this.native.NO_ERROR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INVALID_ENUM", {
        get: function () { return this.native.INVALID_ENUM; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INVALID_VALUE", {
        get: function () { return this.native.INVALID_VALUE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INVALID_OPERATION", {
        get: function () { return this.native.INVALID_OPERATION; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INVALID_FRAMEBUFFER_OPERATION", {
        get: function () { return this.native.INVALID_FRAMEBUFFER_OPERATION; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "OUT_OF_MEMORY", {
        get: function () { return this.native.OUT_OF_MEMORY; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CONTEXT_LOST_WEBGL", {
        get: function () { return this.native.CONTEXT_LOST_WEBGL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CW", {
        get: function () { return this.native.CW; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CCW", {
        get: function () { return this.native.CCW; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DONT_CARE", {
        get: function () { return this.native.DONT_CARE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FASTEST", {
        get: function () { return this.native.FASTEST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NICEST", {
        get: function () { return this.native.NICEST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "GENERATE_MIPMAP_HINT", {
        get: function () { return this.native.GENERATE_MIPMAP_HINT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BYTE", {
        get: function () { return this.native.BYTE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_BYTE", {
        get: function () { return this.native.UNSIGNED_BYTE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_SHORT", {
        get: function () { return this.native.UNSIGNED_SHORT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SHORT", {
        get: function () { return this.native.SHORT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_INT", {
        get: function () { return this.native.UNSIGNED_INT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INT", {
        get: function () { return this.native.INT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT", {
        get: function () { return this.native.FLOAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_COMPONENT", {
        get: function () { return this.native.DEPTH_COMPONENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ALPHA", {
        get: function () { return this.native.ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RGB", {
        get: function () { return this.native.RGB; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RGBA", {
        get: function () { return this.native.RGBA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LUMINANCE", {
        get: function () { return this.native.LUMINANCE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LUMINANCE_ALPHA", {
        get: function () { return this.native.LUMINANCE_ALPHA; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_SHORT_4_4_4_4", {
        get: function () { return this.native.UNSIGNED_SHORT_4_4_4_4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_SHORT_5_5_5_1", {
        get: function () { return this.native.UNSIGNED_SHORT_5_5_5_1; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNSIGNED_SHORT_5_6_5", {
        get: function () { return this.native.UNSIGNED_SHORT_5_6_5; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAGMENT_SHADER", {
        get: function () { return this.native.FRAGMENT_SHADER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VERTEX_SHADER", {
        get: function () { return this.native.VERTEX_SHADER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COMPILE_STATUS", {
        get: function () { return this.native.COMPILE_STATUS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DELETE_STATUS", {
        get: function () { return this.native.DELETE_STATUS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINK_STATUS", {
        get: function () { return this.native.LINK_STATUS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "VALIDATE_STATUS", {
        get: function () { return this.native.VALIDATE_STATUS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ATTACHED_SHADERS", {
        get: function () { return this.native.ATTACHED_SHADERS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ACTIVE_ATTRIBUTES", {
        get: function () { return this.native.ACTIVE_ATTRIBUTES; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ACTIVE_UNIFORMS", {
        get: function () { return this.native.ACTIVE_UNIFORMS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_VERTEX_UNIFORM_VECTORS", {
        get: function () { return this.native.MAX_VERTEX_UNIFORM_VECTORS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_VARYING_VECTORS", {
        get: function () { return this.native.MAX_VARYING_VECTORS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_COMBINED_TEXTURE_IMAGE_UNITS", {
        get: function () { return this.native.MAX_COMBINED_TEXTURE_IMAGE_UNITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_VERTEX_TEXTURE_IMAGE_UNITS", {
        get: function () { return this.native.MAX_VERTEX_TEXTURE_IMAGE_UNITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_TEXTURE_IMAGE_UNITS", {
        get: function () { return this.native.MAX_TEXTURE_IMAGE_UNITS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_VERTEX_ATTRIBS", {
        get: function () { return this.native.MAX_VERTEX_ATTRIBS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_FRAGMENT_UNIFORM_VECTORS", {
        get: function () { return this.native.MAX_FRAGMENT_UNIFORM_VECTORS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SHADER_TYPE", {
        get: function () { return this.native.SHADER_TYPE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SHADING_LANGUAGE_VERSION", {
        get: function () { return this.native.SHADING_LANGUAGE_VERSION; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CURRENT_PROGRAM", {
        get: function () { return this.native.CURRENT_PROGRAM; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NEVER", {
        get: function () { return this.native.NEVER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LESS", {
        get: function () { return this.native.LESS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "EQUAL", {
        get: function () { return this.native.EQUAL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LEQUAL", {
        get: function () { return this.native.LEQUAL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "GREATER", {
        get: function () { return this.native.GREATER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NOTEQUAL", {
        get: function () { return this.native.NOTEQUAL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "GEQUAL", {
        get: function () { return this.native.GEQUAL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ALWAYS", {
        get: function () { return this.native.ALWAYS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "KEEP", {
        get: function () { return this.native.KEEP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "REPLACE", {
        get: function () { return this.native.REPLACE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INCR", {
        get: function () { return this.native.INCR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DECR", {
        get: function () { return this.native.DECR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INVERT", {
        get: function () { return this.native.INVERT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INCR_WRAP", {
        get: function () { return this.native.INCR_WRAP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DECR_WRAP", {
        get: function () { return this.native.DECR_WRAP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NEAREST", {
        get: function () { return this.native.NEAREST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINEAR", {
        get: function () { return this.native.LINEAR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NEAREST_MIPMAP_NEAREST", {
        get: function () { return this.native.NEAREST_MIPMAP_NEAREST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINEAR_MIPMAP_NEAREST", {
        get: function () { return this.native.LINEAR_MIPMAP_NEAREST; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NEAREST_MIPMAP_LINEAR", {
        get: function () { return this.native.NEAREST_MIPMAP_LINEAR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LINEAR_MIPMAP_LINEAR", {
        get: function () { return this.native.LINEAR_MIPMAP_LINEAR; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_MAG_FILTER", {
        get: function () { return this.native.TEXTURE_MAG_FILTER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_MIN_FILTER", {
        get: function () { return this.native.TEXTURE_MIN_FILTER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_WRAP_S", {
        get: function () { return this.native.TEXTURE_WRAP_S; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_WRAP_T", {
        get: function () { return this.native.TEXTURE_WRAP_T; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_2D", {
        get: function () { return this.native.TEXTURE_2D; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE", {
        get: function () { return this.native.TEXTURE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP", {
        get: function () { return this.native.TEXTURE_CUBE_MAP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_BINDING_CUBE_MAP", {
        get: function () { return this.native.TEXTURE_BINDING_CUBE_MAP; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_POSITIVE_X", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_POSITIVE_X; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_NEGATIVE_X", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_NEGATIVE_X; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_POSITIVE_Y", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_POSITIVE_Y; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_NEGATIVE_Y", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_NEGATIVE_Y; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_POSITIVE_Z", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_POSITIVE_Z; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE_CUBE_MAP_NEGATIVE_Z", {
        get: function () { return this.native.TEXTURE_CUBE_MAP_NEGATIVE_Z; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_CUBE_MAP_TEXTURE_SIZE", {
        get: function () { return this.native.MAX_CUBE_MAP_TEXTURE_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE0", {
        get: function () { return this.native.TEXTURE0; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE1", {
        get: function () { return this.native.TEXTURE1; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE2", {
        get: function () { return this.native.TEXTURE2; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE3", {
        get: function () { return this.native.TEXTURE3; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE4", {
        get: function () { return this.native.TEXTURE4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE5", {
        get: function () { return this.native.TEXTURE5; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE6", {
        get: function () { return this.native.TEXTURE6; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE7", {
        get: function () { return this.native.TEXTURE7; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE8", {
        get: function () { return this.native.TEXTURE8; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE9", {
        get: function () { return this.native.TEXTURE9; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE10", {
        get: function () { return this.native.TEXTURE10; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE11", {
        get: function () { return this.native.TEXTURE11; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE12", {
        get: function () { return this.native.TEXTURE12; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE13", {
        get: function () { return this.native.TEXTURE13; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE14", {
        get: function () { return this.native.TEXTURE14; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE15", {
        get: function () { return this.native.TEXTURE15; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE16", {
        get: function () { return this.native.TEXTURE16; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE17", {
        get: function () { return this.native.TEXTURE17; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE18", {
        get: function () { return this.native.TEXTURE18; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE19", {
        get: function () { return this.native.TEXTURE19; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE20", {
        get: function () { return this.native.TEXTURE20; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE21", {
        get: function () { return this.native.TEXTURE21; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE22", {
        get: function () { return this.native.TEXTURE22; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE23", {
        get: function () { return this.native.TEXTURE23; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE24", {
        get: function () { return this.native.TEXTURE24; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE25", {
        get: function () { return this.native.TEXTURE25; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE26", {
        get: function () { return this.native.TEXTURE26; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE27", {
        get: function () { return this.native.TEXTURE27; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE28", {
        get: function () { return this.native.TEXTURE28; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE29", {
        get: function () { return this.native.TEXTURE29; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE30", {
        get: function () { return this.native.TEXTURE30; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "TEXTURE31", {
        get: function () { return this.native.TEXTURE31; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "ACTIVE_TEXTURE", {
        get: function () { return this.native.ACTIVE_TEXTURE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "REPEAT", {
        get: function () { return this.native.REPEAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "CLAMP_TO_EDGE", {
        get: function () { return this.native.CLAMP_TO_EDGE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MIRRORED_REPEAT", {
        get: function () { return this.native.MIRRORED_REPEAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_VEC2", {
        get: function () { return this.native.FLOAT_VEC2; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_VEC3", {
        get: function () { return this.native.FLOAT_VEC3; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_VEC4", {
        get: function () { return this.native.FLOAT_VEC4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INT_VEC2", {
        get: function () { return this.native.INT_VEC2; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INT_VEC3", {
        get: function () { return this.native.INT_VEC3; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "INT_VEC4", {
        get: function () { return this.native.INT_VEC4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BOOL", {
        get: function () { return this.native.BOOL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BOOL_VEC2", {
        get: function () { return this.native.BOOL_VEC2; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BOOL_VEC3", {
        get: function () { return this.native.BOOL_VEC3; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "BOOL_VEC4", {
        get: function () { return this.native.BOOL_VEC4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_MAT2", {
        get: function () { return this.native.FLOAT_MAT2; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_MAT3", {
        get: function () { return this.native.FLOAT_MAT3; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FLOAT_MAT4", {
        get: function () { return this.native.FLOAT_MAT4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLER_2D", {
        get: function () { return this.native.SAMPLER_2D; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "SAMPLER_CUBE", {
        get: function () { return this.native.SAMPLER_CUBE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LOW_FLOAT", {
        get: function () { return this.native.LOW_FLOAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MEDIUM_FLOAT", {
        get: function () { return this.native.MEDIUM_FLOAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "HIGH_FLOAT", {
        get: function () { return this.native.HIGH_FLOAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "LOW_INT", {
        get: function () { return this.native.LOW_INT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MEDIUM_INT", {
        get: function () { return this.native.MEDIUM_INT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "HIGH_INT", {
        get: function () { return this.native.HIGH_INT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER", {
        get: function () { return this.native.FRAMEBUFFER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER", {
        get: function () { return this.native.RENDERBUFFER; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RGBA4", {
        get: function () { return this.native.RGBA4; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RGB565", {
        get: function () { return this.native.RGB565; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RGB5_A1", {
        get: function () { return this.native.RGB5_A1; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_COMPONENT16", {
        get: function () { return this.native.DEPTH_COMPONENT16; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_INDEX8", {
        get: function () { return this.native.STENCIL_INDEX8; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_STENCIL", {
        get: function () { return this.native.DEPTH_STENCIL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_WIDTH", {
        get: function () { return this.native.RENDERBUFFER_WIDTH; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_HEIGHT", {
        get: function () { return this.native.RENDERBUFFER_HEIGHT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_INTERNAL_FORMAT", {
        get: function () { return this.native.RENDERBUFFER_INTERNAL_FORMAT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_RED_SIZE", {
        get: function () { return this.native.RENDERBUFFER_RED_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_GREEN_SIZE", {
        get: function () { return this.native.RENDERBUFFER_GREEN_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_BLUE_SIZE", {
        get: function () { return this.native.RENDERBUFFER_BLUE_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_ALPHA_SIZE", {
        get: function () { return this.native.RENDERBUFFER_ALPHA_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_DEPTH_SIZE", {
        get: function () { return this.native.RENDERBUFFER_DEPTH_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_STENCIL_SIZE", {
        get: function () { return this.native.RENDERBUFFER_STENCIL_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE", {
        get: function () { return this.native.FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME", {
        get: function () { return this.native.FRAMEBUFFER_ATTACHMENT_OBJECT_NAME; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL", {
        get: function () { return this.native.FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE", {
        get: function () { return this.native.FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "COLOR_ATTACHMENT0", {
        get: function () { return this.native.COLOR_ATTACHMENT0; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_ATTACHMENT", {
        get: function () { return this.native.DEPTH_ATTACHMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "STENCIL_ATTACHMENT", {
        get: function () { return this.native.STENCIL_ATTACHMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "DEPTH_STENCIL_ATTACHMENT", {
        get: function () { return this.native.DEPTH_STENCIL_ATTACHMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "NONE", {
        get: function () { return this.native.NONE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_COMPLETE", {
        get: function () { return this.native.FRAMEBUFFER_COMPLETE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_INCOMPLETE_ATTACHMENT", {
        get: function () { return this.native.FRAMEBUFFER_INCOMPLETE_ATTACHMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT", {
        get: function () { return this.native.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_INCOMPLETE_DIMENSIONS", {
        get: function () { return this.native.FRAMEBUFFER_INCOMPLETE_DIMENSIONS; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_UNSUPPORTED", {
        get: function () { return this.native.FRAMEBUFFER_UNSUPPORTED; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "FRAMEBUFFER_BINDING", {
        get: function () { return this.native.FRAMEBUFFER_BINDING; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "RENDERBUFFER_BINDING", {
        get: function () { return this.native.RENDERBUFFER_BINDING; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "MAX_RENDERBUFFER_SIZE", {
        get: function () { return this.native.MAX_RENDERBUFFER_SIZE; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNPACK_COLORSPACE_CONVERSION_WEBGL", {
        get: function () { return this.native.UNPACK_COLORSPACE_CONVERSION_WEBGL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNPACK_FLIP_Y_WEBGL", {
        get: function () { return this.native.UNPACK_FLIP_Y_WEBGL; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSWebGLRenderingContextBase.prototype, "UNPACK_PREMULTIPLY_ALPHA_WEBGL", {
        get: function () { return this.native.UNPACK_PREMULTIPLY_ALPHA_WEBGL; },
        enumerable: true,
        configurable: true
    });
    return TNSWebGLRenderingContextBase;
}());
exports.TNSWebGLRenderingContextBase = TNSWebGLRenderingContextBase;
var TNSPath2DBase = (function () {
    function TNSPath2DBase(instance) {
        this.nativeInstance = instance;
    }
    Object.defineProperty(TNSPath2DBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSPath2DBase;
}());
exports.TNSPath2DBase = TNSPath2DBase;
var TNSDOMMatrixBase = (function () {
    function TNSDOMMatrixBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(TNSDOMMatrixBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return TNSDOMMatrixBase;
}());
exports.TNSDOMMatrixBase = TNSDOMMatrixBase;
var ImageDataBase = (function () {
    function ImageDataBase(nativeInstance) {
        this.width = 0;
        this.height = 0;
        this.data = null;
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(ImageDataBase.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    return ImageDataBase;
}());
exports.ImageDataBase = ImageDataBase;
var CanvasGradientBase = (function () {
    function CanvasGradientBase() {
    }
    return CanvasGradientBase;
}());
exports.CanvasGradientBase = CanvasGradientBase;
var CanvasPattern = (function () {
    function CanvasPattern() {
    }
    return CanvasPattern;
}());
exports.CanvasPattern = CanvasPattern;
var TextMetricsBase = (function () {
    function TextMetricsBase(nativeInstance) {
        this.nativeInstance = nativeInstance;
    }
    return TextMetricsBase;
}());
exports.TextMetricsBase = TextMetricsBase;
var WebGLQuery = (function () {
    function WebGLQuery(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLQuery';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLQuery.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLQuery.prototype.toString = function () {
        return '[object WebGLQuery]';
    };
    return WebGLQuery;
}());
exports.WebGLQuery = WebGLQuery;
var WebGLSampler = (function () {
    function WebGLSampler(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLSampler';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLSampler.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLSampler.prototype.toString = function () {
        return '[object WebGLSampler]';
    };
    return WebGLSampler;
}());
exports.WebGLSampler = WebGLSampler;
var WebGLTransformFeedback = (function () {
    function WebGLTransformFeedback(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLTransformFeedback';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLTransformFeedback.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLTransformFeedback.prototype.toString = function () {
        return '[object WebGLTransformFeedback]';
    };
    return WebGLTransformFeedback;
}());
exports.WebGLTransformFeedback = WebGLTransformFeedback;
var WebGLVertexArrayObject = (function () {
    function WebGLVertexArrayObject(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLVertexArrayObject';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLVertexArrayObject.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLVertexArrayObject.prototype.toString = function () {
        return '[object WebGLVertexArrayObject]';
    };
    return WebGLVertexArrayObject;
}());
exports.WebGLVertexArrayObject = WebGLVertexArrayObject;
var WebGLSync = (function () {
    function WebGLSync(nativeInstance) {
        this[Symbol.toStringTag] = 'WebGLSync';
        this.nativeInstance = nativeInstance;
    }
    Object.defineProperty(WebGLSync.prototype, "native", {
        get: function () {
            return this.nativeInstance;
        },
        enumerable: true,
        configurable: true
    });
    WebGLSync.prototype.toString = function () {
        return '[object WebGLSync]';
    };
    return WebGLSync;
}());
exports.WebGLSync = WebGLSync;
//# sourceMappingURL=canvas-plugin.common.js.map